CON

   _clkmode       = xtal1 + pll8x
   _xinfreq       = 10_000_000

   AMBLED         = 6
   REDLED         = 5
   GRNLED         = 4
   BLULED         = 3

VAR

  word buf_addr[8]
  byte amb_pix[128], red_pix[128], grn_pix[128], blu_pix[128]  'Must begin on long boundary.
   

OBJ

  tsl   :       "TSL1401-DB_driver"
  pst   :       "Parallax Serial Terminal"

PUB  Start | led, i, maxpix, exp


  tsl.start
  exp := clkfreq / 120
  pst.start(115200)
  buf_addr[AMBLED] := @amb_pix
  buf_addr[REDLED] := @red_pix
  buf_addr[GRNLED] := @grn_pix
  buf_addr[BLULED] := @blu_pix

  repeat
    exp <#= clkfreq / 3
    tsl.setexp(exp)
    tsl.snap
    maxpix~  
    repeat led from AMBLED to BLULED
      dira[led]~~
      tsl.snap
      tsl.getpix(buf_addr[led])
      maxpix #>= tsl.getstats >> 8 & $ff
      dira[led]~
    exp := (exp * 7 + exp * $f0 / maxpix) >> 3
    pst.char(0)
    pst.str(string("1401", 13))
    repeat i from 0 to 511
      pst.char(amb_pix[i])
   



